#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <assert.h>
#include <crypt.h>

char *ct = NULL;
int cp, cl;

void crypt( char *buf ) {
        *buf ^= ct[ cp ] ^ (ct[ 0 ] * cp );
        ct[ cp ] += ( (cp < (cl - 1) ) ? ct[ cp + 1 ] : ct[ 0 ] );
        if( !ct[ cp ] ) ct[ cp ] += 1;
        if( ++cp >= cl ) cp = 0;
}

void cryptsetup( char *key ) {
        if( ct != NULL ) free( ct );
        cl = strlen( key );
        ct = calloc( cl );
        strcpy( ct, key );
}

main( int argc, char *argv[] ) {
	char cch;
	int ich;
	FILE *fp;

	if( argc < 2 ) {
		printf( "\aUsage: %s key", argv[ 0 ] );
		puts( "encrypts stdin to stdout" );
		exit( 1 );
	}
	cryptsetup( argv[ 1 ] );

	/* must set to RAW mode to avoid CR/LF conversions and
		seeing 0x1a as EOF */

/* only unbuffers stdin & stdout
	setvbuf(  stdin, NULL, _IONBF, 0 );
	setvbuf( stdout, NULL, _IONBF, 0 );
*/
	setmode( fileno(  stdin ), O_BINARY );
	setmode( fileno( stdout ), O_BINARY );
	while( (ich = getchar()) != EOF ) {
		cch = (char)ich;
		crypt( &cch );
		fputc( cch, stdout );
	}
	exit( 0 );
}
